##############################################################################
#
# Copyright (c) 2001 Zope Corporation and Contributors. All Rights Reserved.
# 
# This software is subject to the provisions of the Zope Public License,
# Version 2.0 (ZPL).  A copy of the ZPL should accompany this distribution.
# THIS SOFTWARE IS PROVIDED "AS IS" AND ANY AND ALL EXPRESS OR IMPLIED
# WARRANTIES ARE DISCLAIMED, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
# WARRANTIES OF TITLE, MERCHANTABILITY, AGAINST INFRINGEMENT, AND FITNESS
# FOR A PARTICULAR PURPOSE
# 
##############################################################################
"""
CMF Weather Tool Installation script

 id:            cmf_install_weather
 title:         
 module name:   ZWeatherApplet.Install
 function name: install

"""

import string
from cStringIO import StringIO
from Products.CMFCore.DirectoryView import addDirectoryViews
from Products.CMFCore.utils import getToolByName
from Products.ZWeatherApplet import weather_globals
from Products.ZWeatherApplet.WeatherTool import WeatherTool

def install(self):
    """
    Register "Wiki Page" with portal_types and friends.
    """
    out = StringIO()
    skinstool = getToolByName(self, 'portal_skins')
    
    # Setup the skins
    # This is borrowed from CMFDefault/scripts/addImagesToSkinPaths.pys
    if 'weather' not in skinstool.objectIds():
        # We need to add Filesystem Directory Views for any directories
        # in our skins/ directory.  These directories should already be
        # configured.
        addDirectoryViews(skinstool, 'skins', weather_globals)
        out.write("Added weather skin directories to portal_skins\n")

    # Now we need to go through the skin configurations and insert
    # 'zwiki_plone'.  Preferably, this should be right before where
    # 'content' is placed.  Otherwise, we append it to the end.
    skins = skinstool.getSkinSelections()
    for skin in skins:
        path = skinstool.getSkinPath(skin)
        path = map(string.strip, string.split(path,','))
        for dir in ('weather',):
            if not dir in path:
                try:
                    idx = path.index('custom')
                except ValueError:
                    idx = 999
                path.insert(idx+1, dir)

        path = string.join(path, ', ')
        # addSkinSelection will replace existing skins as well.
        skinstool.addSkinSelection(skin, path)
        out.write("Added 'weather' to %s skin\n" % skin)

    # Add portlet
    macros = 'here/portlet_weather/macros/portlet'
    slots  = self.getProperty('right_slots')
    if self.hasProperty('right_slots') and macros not in slots:
        rs = (macros,) + slots
        self.manage_changeProperties({'right_slots':rs})
        out.write("Added 'portlet_weather' to right_slots\n")

    # create weather tool
    qt=WeatherTool()
    self._setObject('portal_weather',qt,set_owner=0)
    out.write("Added 'portal_weather' tool.\n")

    return out.getvalue()

